Subject: Re: GFP_ATOMIC page allocation failures.

From: Jeff Garzik <[email-masked]>
Date: Thu, 03 Apr 2008 14:20:03 -0400

Nick Piggin wrote:
> On Thursday 03 April 2008 05:18, Jeff Garzik wrote:
> 
>> Turning to Nick's comment,
>>
>>> It's still actually nice to know how often it is happening even for
>>> these known good sites because too much can indicate a problem and
>>> that you could actually bring performance up by tuning some things.
>> then create a counter or acculuation buffer somewhere.
>>
>> We don't need spew every time there is memory pressure of this magnitude.
> 
> Not a complete solution. Counter would be nice, but you need backtraces
> and want a way to more proactively warn the user/tester/developer.
> 
> I agree that I don't exactly like adding nowarns around, and I don't think
> places like driver writers should have to know about this stuff.
> 
> 
>> IMO there are much better ways than printk(), to inform tasks, and
>> humans, of allocation failures.
> 
> I think with a tweaked warning message, a ratelimited printk is OK.

No objections here, and agreed on all points.

Though IMO adding __GFP_NOWARN to netdev_alloc_skb() falls into that 
category (should not generally be in a driver or driver API).

	Jeff